/*
ConvertOptions.cc
Program to convert user configuration files from Postman v.1.0 to 1.1
Usage: "ConvertOptions filename"
WARNING! "ConvertOptions" overwrite the infile with the outfile.

COMPILE WITH: 
  (LINUX) gcc -O -DLINUX -DMANT=0 -g -I. -I../imap-2000a/c-client -o ConvertOptions Configuration.o XString.o Utils.o Language.o XSocket.o ConvertOptions.cc
  (HP)    CC -O -DHP -DMANT=0 -g +a1 -I. -I../imap-2000a/c-client -o ConvertOptions Configuration.o XString.o Utils.o Language.o XSocket.o ConvertOptions.cc
*/

#include "Language.h"

Language *L;

int main (int argc, char **argv)
  {
  FILE *fin, *fout;
  StringList SLFile;
  char Buffer[501];
  
  fin = fopen (argv[1], "r");
  if (NULL == fin) {fprintf (stderr, "Error opening file for read: '%s'\n", argv[1]); return -1;}
  while (NULL != fgets (Buffer, 500, fin))
    {
    SLFile.Add (Buffer);              
    }
  fclose (fin);
  if (SLFile.Count() != 8) {fprintf (stderr, "Error: Numero de lineas incorrecto en: '%s'\n", argv[1]); return -1;}       
  fout = fopen (argv[1], "w");
  if (NULL == fout) {fprintf (stderr, "Error opening file for write: '%s'\n", argv[1]); return -1;}
  fprintf (fout, "[main]\n");
  fprintf (fout, "msgsperindexpage=%s", (char *)SLFile.getString(0).cstr()); 
  fprintf (fout, "insigninnewmsg=%s",   (char *)SLFile.getString(1).cstr());
  fprintf (fout, "personalname=%s",     (char *)SLFile.getString(2).cstr());
  fprintf (fout, "savemsgsentmail=%s",  (char *)SLFile.getString(3).cstr());
  fprintf (fout, "replyfrom=%s",        (char *)SLFile.getString(4).cstr());
  fprintf (fout, "forwattachs=%s",      (char *)SLFile.getString(5).cstr());
  fprintf (fout, "heightwritearea=%s",  (char *)SLFile.getString(6).cstr());        
  fprintf (fout, "widthwritearea=%s",   (char *)SLFile.getString(7).cstr());
  fprintf (fout, "truncatelengthreadingmsg=90\n");  
  fprintf (fout, "skin=DEFAULT\n");    
  fprintf (fout, "\n");
  fclose (fout);
  return 0;
  }
