/*
SendMSG.h
*/

#ifndef __SendMSG_H
#define __SendMSG_H

#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <signal.h>

#include "c-client.h"

#include "Language.h"
#include "Utils.h"
#include "Config.h"
#include "XSocket.h"
#include "XVector.h"
#include "Codecs.h"
#include "UserOptions.h"
#include "IMAP.h"

char *MakeBoundary (void);
char *MakeMidBoundary (const char *boundary);
char *MakeEndBoundary (const char *boundary);
char *MakeContentID (const char *user, const char *maildomain);

class SendMSG
  {
  private:
    char *localhost, *user, *to, *cc, *bcc, *subject, 
         *personalname, *firsttext, *defaulthost, *smtpserver;
    bool Quoted, savemsginsentmail;
    UserOptions *uo;
    IMAP *imap;
    StringList SLTO, SLCC, SLBCC;
  public:
    SendMSG (const char *asmtpserver, char *flname, UserOptions *auo, 
             const char *adefaulthost, IMAP *aimap);
    virtual ~SendMSG ();  
    void setTO  (char *ato);
    void setCC  (char *acc);
    void setBCC (char *abcc);
    void setSUBJECT (char *asubject);
    void setPERSONALNAME  (char *apersonalname);
    void setFIRSTTEXT (char *afirsttext);
    char *getTO (void);
    char *getCC (void);
    char *getBCC (void);
    char *getSUBJECT (void);
    char *getPERSONALNAME (void);
    char *getFIRSTTEXT (void);
    void DelAttachs (void);
    void ExtraeAddresses (StringList *SL, char *linea);
    bool sendSMTP (TBuffer errormsg);
  };
  
#endif

